VERSION 5.00
Begin VB.Form Main 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ISM 2.4GHz Band Spectrum Analyser"
   ClientHeight    =   6285
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8145
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6285
   ScaleWidth      =   8145
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HoldTime 
      Height          =   255
      LargeChange     =   50
      Left            =   480
      Max             =   749
      Min             =   1
      SmallChange     =   10
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   5580
      Value           =   350
      Width           =   2895
   End
   Begin VB.PictureBox G 
      AutoRedraw      =   -1  'True
      Height          =   4515
      Left            =   420
      ScaleHeight     =   4455
      ScaleWidth      =   7215
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   480
      Width           =   7275
   End
   Begin VB.CommandButton Export 
      Caption         =   "Export"
      Height          =   375
      Left            =   6540
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   5520
      Width           =   1155
   End
   Begin VB.CommandButton Pause 
      Caption         =   "Pause"
      Height          =   375
      Left            =   4440
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   5520
      Width           =   1155
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "30 Sec"
      Height          =   195
      Left            =   480
      TabIndex        =   6
      Top             =   5880
      Width           =   2895
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Peak Hold Time"
      Height          =   195
      Left            =   540
      TabIndex        =   5
      Top             =   5280
      Width           =   2835
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   420
      TabIndex        =   4
      Top             =   120
      Width           =   5955
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'    Version 1.0   Nov 2009
'
'    Copyright 2009 Geoff Graham - http://geoffg.net
'    This program is free software: you can redistribute it and/or modify it under the terms of the GNU General
'    Public License as published by the Free Software Foundation, either version 2 of the License, or (at your
'    option) any later version.
'
'    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
'    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
'    for more details.  You should have received a copy of the GNU General Public License along with this program.
'    If not, see <http://www.gnu.org/licenses/>.

Const NbrChan = 85                          ' number of MHz (must be the same as in the 18F2550 firmware)
Const Margin = 600                          ' top/bottom margin for the freq scale (in twips)
    
Dim ScannerData(0 To NbrChan) As Byte
Dim da(0 To NbrChan, 0 To 750) As Integer
Dim Paused As Boolean
Dim Exporting As Boolean


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' functions associated with reading data from the scanner and displaying it
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'
' Form load
'
' The main program loop (open/read/display) occurs within the form load event
' This loop will run continuously while the program is running
'
Private Sub Form_Load()

    Dim r As Long
    
    Main.Show
    DrawScale
    HoldTime_Change
    
    On Error Resume Next
    r = MPUSBGetDLLVersion()
    If Err Then
        MsgBox "Cannot find mpusbapi.dll" + vbCrLf + _
        "This should be installed in the same directory as ISMScanner.exe", 16, App.FileDescription
        Unload Main
    End If
    On Error GoTo 0

    Do
        Do While Not OpenScanner()
            DoEvents
        Loop
        
        ClearDA
        
        Do While GetLastError() <> ERROR_INVALID_HANDLE And MPUSBGetDeviceCount(vid_pid) > 0
            If GetScannerData() Then If Not Paused Then DisplayData
            DoEvents
        Loop
        
        CloseMPUSBDevice
        DoEvents
    Loop
    
End Sub

'
' draw the frequency scales on the display
' because the picture control is set with AutoRedraw on we do not have to wory about paint events
' and do this just once
'
Private Sub DrawScale()
    Dim i As Integer
    Dim j As Integer
    Dim x As Integer

    G.CurrentX = (G.ScaleWidth - G.TextWidth("Frequency   (GHz)")) / 2
    G.CurrentY = 20
    G.Print "Frequency   (GHz)"
    G.CurrentX = (G.ScaleWidth - G.TextWidth("802.11 b/g   Channel")) / 2
    G.CurrentY = G.ScaleHeight - 210
    G.Print "802.11 b/g   Channel"
    
    For i = 0 To NbrChan
        x = i * (G.ScaleWidth / NbrChan)
        
        ' draw the frequency scale
        If i Mod 10 = 0 Then
            G.Line (x + (G.ScaleWidth / NbrChan) / 2, Margin - 100)-(x + (G.ScaleWidth / NbrChan) / 2, Margin - 20)
            G.CurrentX = x + (G.ScaleWidth / NbrChan) / 2 - G.TextWidth("2.4" & Format$(i / 10)) / 2
            If i = 0 Then G.CurrentX = 0
            G.CurrentY = 240
            G.Print "2.4" & Format$(i / 10)
        Else
            G.Line (x + (G.ScaleWidth / NbrChan) / 2, Margin - 100)-(x + (G.ScaleWidth / NbrChan) / 2, Margin - 70)
        End If
        
        ' draw the WiFi channel scale
        If i >= 12 And i <= 72 And (i - 12) Mod 5 = 0 Then
            G.Line (x + (G.ScaleWidth / NbrChan) / 2, G.ScaleHeight - Margin + 40)-(x + (G.ScaleWidth / NbrChan) / 2, G.ScaleHeight - Margin + 150)
            G.CurrentY = G.CurrentY + 40
            G.CurrentX = x + (G.ScaleWidth / NbrChan) / 2 - G.TextWidth(Format$(((i - 12) / 5) + 1)) / 2
            G.Print Format$(((i - 12) / 5) + 1)
        End If
    Next i
End Sub


'
' This routine controls the handling and display of the data received from the scanner
'
Sub DisplayData()
    Dim i As Integer
    Dim j As Integer
    Dim x As Integer
    Dim y As Integer
    Dim p As Integer
        
    If Exporting Then
        Print #1, Format$(ScannerData(0)) & ", ";
        For i = 1 To NbrChan - 1
            Print #1, Format$(ScannerData(i)) & ", ";
        Next i
        Print #1,
    End If
        
    For i = 0 To NbrChan
        For j = HoldTime.Value - 1 To 0 Step -1
            da(i, j + 1) = da(i, j)
        Next j
        da(i, 0) = ScannerData(i)
        
        ' get the peak signal level
        p = 0
        For j = 0 To HoldTime.Value
            If da(i, j) > p Then p = da(i, j)
        Next j
        
        ' draw the signal level
        x = i * (G.ScaleWidth / NbrChan)
        If p < 2 Then p = 2
        y = (p - 2) * ((G.ScaleHeight - (Margin * 2)) / 30) + Margin
        G.Line (x, G.ScaleHeight - Margin)-(x + (G.ScaleWidth / NbrChan), G.ScaleHeight - y), RGB(78, 137, 88), BF
        G.Line (x, G.ScaleHeight - y)-(x + (G.ScaleWidth / NbrChan), Margin), RGB(255, 255, 255), BF
    Next i
    
End Sub


Private Sub Export_Click()
    Dim i As Integer
    If Exporting Then
        If MsgBox("Terminate the export of data to C:\Spectrum.csv ?", 65, App.FileDescription) = vbOK Then
            Exporting = False
            Export.Caption = "Export"
            Close #1
            Exit Sub
        Else
            Exit Sub
        End If
    Else
        If MsgBox("Data will be recorded in C:\Spectrum.csv", 65, App.FileDescription) = vbOK Then
            Open "C:\Spectrum.csv" For Output As #1
            Print #1, "2400 MHz, ";
            For i = 2401 To 2400 + NbrChan - 1
                Print #1, Format$(i) & " MHz, ";
            Next i
            Print #1,
            Exporting = True
            Export.Caption = "Stop Export"
        Else
            Exit Sub
        End If
    End If
End Sub


Sub ClearDA()
    Dim i As Integer
    Dim j As Integer
        
    For i = 0 To NbrChan
        For j = HoldTime.Value - 1 To 0 Step -1
            da(i, j) = 0
        Next j
    Next i
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Routines associated with maintaining the form and the controls on it
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub Form_Unload(Cancel As Integer)
    CloseMPUSBDevice
    DoEvents
    On Error Resume Next
    Unload Main
    On Error GoTo 0
    End                         ' Just to be sure the program has ended
End Sub


Private Sub Close_Click()
    CloseMPUSBDevice
    Unload Main
End Sub


Private Sub HoldTime_Change()
            Label2 = Format$(HoldTime.Value) & " readings"
End Sub


Private Sub Pause_Click()
    Paused = (Not Paused)
    If Paused Then
        Pause.Caption = "Run"
        ClearDA
    Else
        Pause.Caption = "Pause"
    End If
End Sub


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Scanner specific functions
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'
' Open the scanner for input only
'
Function OpenScanner() As Boolean
    CloseMPUSBDevice
    OpenMPUSBDevice
    If myInPipe = INVALID_HANDLE_VALUE Then
        Label1.Caption = "Scanner not found"
        OpenScanner = False
    Else
        Label1.Caption = "Connected to Geoff's 2.4GHz Scanner"
        If Paused Then Pause_Click
        OpenScanner = True
    End If
End Function

'
' Read data from the scanner
' Data is delivered in two packets, the first being 64 bytes and the second the remaining bytes
' of the message.  It is possible that the sender timed out on the first packet and we start by
' trying to read the second packet.  This is handled by the login in this function.
'
' return true when it has copied the message into ScannerData()
' or false if there was an error
'
Function GetScannerData() As Boolean
    Dim ExpectedReceiveLength As Long
    Dim ReceiveLength As Long
    
    ' state 1:  Try to read the first packet
    ExpectedReceiveLength = 64
    If MPUSBGetDeviceCount(vid_pid) = 0 Then Exit Function
    If (MPUSBRead(myInPipe, VarPtr(ScannerData(0)), ExpectedReceiveLength, ReceiveLength, 250) <> MPUSB_SUCCESS) Then Exit Function
    If (ReceiveLength = 64) Then GoTo STATE_3
    If (ReceiveLength <> NbrChan - 64) Then Exit Function
    
    ' state 2:  Try again for the first packet
    ExpectedReceiveLength = 64
    If MPUSBGetDeviceCount(vid_pid) = 0 Then Exit Function
    If (MPUSBRead(myInPipe, VarPtr(ScannerData(0)), ExpectedReceiveLength, ReceiveLength, 250) <> MPUSB_SUCCESS) Then Exit Function
    If (ReceiveLength <> 64) Then Exit Function
    
STATE_3:
    ' state 3:  Read the second packet
    ExpectedReceiveLength = NbrChan - 64
    If MPUSBGetDeviceCount(vid_pid) = 0 Then Exit Function
    If (MPUSBRead(myInPipe, VarPtr(ScannerData(64)), ExpectedReceiveLength, ReceiveLength, 250) <> MPUSB_SUCCESS) Then Exit Function
    If (ReceiveLength <> NbrChan - 64) Then Exit Function
    
    GetScannerData = True

End Function


'
' Open the scanner
' myInPipe = INVALID_HANDLE_VALUE if the open failed
'
Sub OpenMPUSBDevice()

myInPipe = INVALID_HANDLE_VALUE
If MPUSBGetDeviceCount(vid_pid) > 0 Then
    myInPipe = MPUSBOpen(0, vid_pid, in_pipe, MP_READ, 0)
End If
   
End Sub

'
' Closes the scanner
'
Sub CloseMPUSBDevice()
If myInPipe <> INVALID_HANDLE_VALUE Then
    MPUSBClose (myInPipe)
    myInPipe = INVALID_HANDLE_VALUE
End If
End Sub

